<?php

namespace YPS\WC_Conditional_Cart_Notices;

use YPS\WC_Conditional_Cart_Notices\Framework\Record\Record_Controller;

class Template_Controller extends Record_Controller {

    public $template_model;
    public $template_config;
    
    public function __construct($context, $params = array()) {
        
        $this->template_model               = new Template_Model($context);
        $this->template_config              = new Template_Config($context);
        
        $this->set_record_entity(new Template_Entity($context, $params));
        $this->set_record_config(new Template_Config($context, $params));
        $this->set_record_table(new Template_Table($context, $params));
        $this->set_record_model($this->template_model);
        $this->set_record_form(new Template_Form($context, $params));
        
        $this->set_record_singular_name("Template");
        $this->set_record_plural_name("Templates");

        $this->set_list_title(__("Template List", "yps-wc-conditional-cart-notices"));
        
        $this->list_show_card           = false;
        $this->show_actions_new_button  = true;

        parent::__construct($context, $params);
    }

    public function index_action()
    {
        parent::index_action();
    }

}



