<?php

namespace YPS\Framework\Form\v481_380_927;

class Html_List_Field extends Form_Field {
    
    protected $items                = array();

    protected $modal_view           = null;
    protected $modal_ajax_url       = null;
    protected $save_item_ajax_url   = null;

    protected $modal_ajax_custom_data   = null;
    
    public function __construct($context, $params = array()) {

        $this->set_type("html-list");

        parent::__construct($context, $params);
    }

    /**
     * Add a new item to the HTML list

     * @param string $key Item Unique Key
     * @param array $meta Item Data
     * @param string $item_view Item View
     */
    public function add_item($key, $meta, $item_view){
        $this->items[$key]  = array(
            'key'   => $key,
            'meta'  => $meta,
            'view'  => $item_view
        );
    }

    public function get_save_item_ajax_url(){
        return $this->save_item_ajax_url;
    }

    public function set_save_item_ajax_url($save_item_ajax_url){
        $this->save_item_ajax_url    = $save_item_ajax_url;
    }

    /**
     * Get all items
     */
    public function get_items(){
        return $this->items;
    }

    /**
     * Get the modal view
     */
    public function get_modal_view(){
        return $this->modal_view;
    }

    /**
     * Set the modal view
     */
    public function set_modal_view($modal_view){
        $this->modal_view   = $modal_view;
    }


    /**
     * Get the value of modal_ajax_url
     */ 
    public function get_modal_ajax_url()
    {
        return $this->modal_ajax_url;
    }

    /**
     * Set the value of modal_ajax_url
     *
     * @return  self
     */ 
    public function set_modal_ajax_url($modal_ajax_url)
    {
        $this->modal_ajax_url = $modal_ajax_url;

        return $this;
    }

    /**
     * Get the value of modal_ajax_custom_data
     */ 
    public function get_modal_ajax_custom_data()
    {
        return htmlentities(json_encode($this->modal_ajax_custom_data));
    }

    /**
     * Set the value of modal_ajax_custom_data
     *
     * @return  self
     */ 
    public function set_modal_ajax_custom_data($modal_ajax_custom_data)
    {
        $this->modal_ajax_custom_data = $modal_ajax_custom_data;

        return $this;
    }
}
