<?php

namespace YPS\Framework\Form\v481_380_927;

use YPS\Framework\Core\v481_380_927\Controller;

class Multiple_List_Adder_Form_Field extends Form_Field {

    protected $add_button_icon;
    protected $add_button_text;

    protected $delete_button_icon;
    protected $delete_button_text;
    
    protected $modal_ajax_url;
    
    protected $modal;

    protected $items;
    
    public static $record_list_footer_hooks     = array();

    public function __construct($context, $params = array()) {

        $this->set_type("multiple-list-adder");
        $this->set_attributes(array('class' => array('form-control')));
        
        $this->set_add_button_text("Add");
        $this->set_add_button_icon("fas fa-plus");

        $this->set_delete_button_text("Delete");
        $this->set_delete_button_icon("fas fa-trash");

        $this->modal        = new Modal_Form_Field($context);
        $this->modal->add_class("multiple-list-adder-modal");

        $this->items        = array();

        parent::__construct($context, $params);
    }

	public function get_custom_field_view_params($view_params){

        $this->modal->set_name($this->get_name());

        $view_params        = array_merge($view_params, array(
            'controller'                => new Controller($this->context, $this->params),
            'modal'                     => $this->modal,
            'items'                     => $this->get_items(),
        ));

		return $view_params;
	}

    public function get_option_label($option_id){
        return $option_id;
    }

    /**
     * Get the value of button icon
     */ 
    public function get_add_button_icon()
    {
        return $this->add_button_icon;
    }

    /**
     * Set the value of button icon
     *
     * @return  self
     */ 
    public function set_add_button_icon($add_button_icon)
    {
        $this->add_button_icon = $add_button_icon;

        return $this;
    }

    /**
     * Get the value of button_text
     */ 
    public function get_add_button_text()
    {
        return $this->add_button_text;
    }

    /**
     * Set the value of button_text
     *
     * @return  self
     */ 
    public function set_add_button_text($add_button_text)
    {
        $this->add_button_text = $add_button_text;

        return $this;
    }

    /**
     * Get the value of delete_button_icon
     */ 
    public function get_delete_button_icon()
    {
        return $this->delete_button_icon;
    }

    /**
     * Set the value of delete_button_icon
     *
     * @return  self
     */ 
    public function set_delete_button_icon($delete_button_icon)
    {
        $this->delete_button_icon = $delete_button_icon;

        return $this;
    }

    /**
     * Get the value of delete_button_text
     */ 
    public function get_delete_button_text()
    {
        return $this->delete_button_text;
    }

    /**
     * Set the value of delete_button_text
     *
     * @return  self
     */ 
    public function set_delete_button_text($delete_button_text)
    {
        $this->delete_button_text = $delete_button_text;

        return $this;
    }

    /**
     * Get the value of modal_ajax_url
     */ 
    public function get_modal_ajax_url()
    {
        return $this->modal_ajax_url;
    }

    /**
     * Set the value of modal_ajax_url
     *
     * @return  self
     */ 
    public function set_modal_ajax_url($modal_ajax_url)
    {
        $this->modal_ajax_url = $modal_ajax_url;

        return $this;
    }

    /**
     * Get the value of modal
     */ 
    public function get_modal()
    {
        return $this->modal;
    }

    /**
     * Set the value of modal
     *
     * @return  self
     */ 
    public function set_modal($modal)
    {
        $this->modal = $modal;

        return $this;
    }



    /**
     * Get the value of items
     */ 
    public function get_items()
    {
        return $this->items;
    }

    /**
     * Set the value of items
     *
     * @return  self
     */ 
    public function set_items($items)
    {
        $this->items = $items;

        return $this;
    }
}
