YPS_Framework.Form.Html_List_Field        = class {

    html_list   = null;
    $class      = null;
    
    constructor(html_list){
        this.html_list  = html_list;
    }

    load(){
        var $this       = this;
        window.$        = jQuery;

        $this.update_data();
        
        /* Select first element */
        $(this.html_list).find(".item").first().addClass("selected");

        /* Show the modal to add field */
        $(this.html_list).on('click', '[data-action="add"]', function(){
            $this.show_modal("add");
        });

        /* Show modal to edit the item */
        $(this.html_list).on('click', '[data-action="edit"]', function(){
            $this.show_modal("edit");
        });

        /* Delete the item */
        $(this.html_list).on('click', '[data-action="delete"]', function(){
            if(confirm("Are you sure you want to delete this item?")){
                var selected_item       = $this.get_selected_item();

                /* If item is deleted, next or prev item is selected */
                if($(selected_item).next().length != 0 && $(selected_item).prev().length == 0){
                    $(selected_item).next().addClass("selected");
                }else if($(selected_item).next().length == 0 && $(selected_item).prev().length != 0){
                    $(selected_item).prev().addClass("selected");
                }else{
                    $(selected_item).prev().addClass("selected");
                }

                $(selected_item).remove();
                $this.update_data();
            }
        });

        /* Move the item up */
        $(this.html_list).on('click', '[data-action="move-up"]', function(){
            var selected_item       = $this.get_selected_item();
            $(selected_item).insertBefore($(selected_item).prev());

            $this.update_data();
        });

        /* Move the item down */
        $(this.html_list).on('click', '[data-action="move-down"]', function(){
            var selected_item       = $this.get_selected_item();
            $(selected_item).insertAfter($(selected_item).next());

            $this.update_data();
        });

        /* Click on item */
        $(this.html_list).on('click', '.item', function(){
            $this.unselect_all_items();
            $(this).addClass('selected');
        });

        /* Click on modal save button */
        $(this.html_list).on('click', '[data-action="save"]', function(){
            
            var save_item_ajax_url   = $($this.html_list).attr('data-save-item-ajax-url');
            $(document).trigger('yps_html_list_save');

            console.log($($this.html_list).find(".form").find("*").serializeJSON());

            $($this.html_list).find(".form [name='form_task']").val("save");

            $.ajax({
                type:'POST',
                url: save_item_ajax_url,
                data: {
                    'form_data'     : $($this.html_list).find(".form").find("*").serializeJSON(),
                    'custom_data'   : JSON.parse($($this.html_list).attr('data-modal-ajax-custom-data')),   
                },
                dataType: "json",
                success:function(data){

                    if(data.json.status == true){
                        var selected_item       = $this.get_selected_item();
                        var json_meta           = he.encode(JSON.stringify(data.json.item.meta));
                        var html_item           = `<div data-key="${data.json.item.key}" data-meta="${json_meta}" class="item selected">`;
                        html_item               += data.json.item.html;
                        html_item               += '</div>';
    
                        $this.unselect_all_items();
    
                        if($this.get_modal_action() == "add"){
                            $($this.html_list).find(".content").append(html_item);
                        }
    
                        if($this.get_modal_action() == "edit"){
                            $(selected_item).replaceWith(html_item);
                        }
    
                        $this.update_data();
                        $this.hide_modal();
                    }else{
                        $($this.html_list).find(".form").html(data.html);
                    }

                },

                error: function(data){
                    console.log(data);
                }
            });
            
        });
    }

    get_modal_action(){
        var modal   = $(this.html_list).find(".modal");

        return $(modal).attr('data-modal-action');
    }
    
    get_modal_ajax_content(success_callback){

        var $this           = this;
        var modal_ajax_url  = $(this.html_list).attr('data-modal-ajax-url');
        
        $($this.html_list).find(".form [name='form_task']").val("");

        $.ajax({
            type:'POST',
            url: modal_ajax_url,
            data: {
                'form_data'     : $($this.html_list).find(".form").find("*").serializeJSON(),
                'custom_data'   : JSON.parse($($this.html_list).attr('data-modal-ajax-custom-data')),
            },
            dataType: "json",
            success:function(data){
                $($this.html_list).find(".form").html(data.html);

                success_callback();
            },

            error: function(data){
                console.log(data);
            }
        });

    }

    show_modal(modal_action){

        var $this   = this;
        var modal   = $(this.html_list).find(".modal");
        
        if(modal_action == 'add'){
            $(modal).find('.modal-title').text('Add...');
        }else{
            $(modal).find('.modal-title').text('Edit...');
        }


        this.get_modal_ajax_content(function(){
            if(modal_action == 'edit'){
                var selected_item   = $this.get_selected_item();
                var item_meta       = $this.get_item_meta(selected_item);
                var modal           = $($this.html_list).find(".modal");

                $.each(item_meta, function(id, value){
                    $(modal).find(`[name="${id}"]`).val(value);
                });
            }
        });

        $(modal).attr('data-modal-action', modal_action);
        $(modal).modal('show');
    }

    hide_modal(){
        $(this.html_list).find(".modal").modal('hide');
    }

    get_selected_item(){
        return $(this.html_list).find(".item.selected");
    }

    get_item_meta(item){
        var meta        = he.decode($(item).attr('data-meta'));

        return JSON.parse(meta);
    }

    unselect_all_items(){
        $(this.html_list).find(".item").removeClass("selected");
    }

    update_data(){

        var data    = [];
        var $this   = this;

        $.each($(this.html_list).find(".item"), function(index, item){
            data.push($this.get_item_meta(item));
        });

        $(this.html_list).find("[data]").val(he.encode(JSON.stringify(data)));
    }

}

jQuery(document).ready(function($){
    $.each($(".yps-html-list"), function(index, html_list){
        var html_list_field = new YPS_Framework.Form.Html_List_Field(html_list);

        html_list_field.load();
    });
    
});