<?php

namespace YPS\Framework\Plugin\v481_380_927;

use YPS\Framework\Core\v481_380_927\Application;

class Plugin extends Application {
    
    var $enqueue_helper;
    var $license_controller_class;

    public function init(){
        parent::init();

        add_shortcode('yps-plugin-header', array($this, 'plugin_header'));
        add_shortcode('yps-plugin-footer', array($this, 'plugin_footer'));

        add_action('admin_menu', array($this, 'plugin_admin_menu'), 9);
        add_action('admin_menu', array($this, 'plugin_sub_admin_menu'), 1000);

        $this->license_controller_class     = '\YPS\Framework\Plugin\v481_380_927\License_Controller';
        
    }

    public function plugin_admin_menu(){

        global $admin_page_hooks;

        if(!isset($admin_page_hooks['yourplugins'])){
            if(current_user_can('administrator')) {
                add_menu_page( 
                    'YourPlugins', 
                    'YourPlugins', 
                    'read', 
                    "yourplugins",
                    array($this, 'plugin_submenu_callback'),
                    $this->context->get_framework_url("Plugin", "images/logo-24x24.png"),
                    100
                );
            }
        }

    }

    public function plugin_sub_admin_menu(){
        /*
        add_submenu_page(
            "yourplugins",
            "License",
            "License",
            'read',
            "yourplugins&controller=license&parent_plugin={$this->context->get_plugin_code()}",
            array($this, 'plugin_submenu_callback')
        );
        */   
    }

    public function plugin_submenu_callback() {

    }

    function is_current_hook_suffix($hook_suffix){
        if($hook_suffix == "yourplugins_page_{$this->context->get_plugin_code()}"){
            return true;
        }
        
        return false;
    }
    
    /**
     * Loading styles and scripts only on wp-admin pages.
     *
     * @param string $hook_suffix
     * @return void
     */
    function admin_enqueue_scripts($hook_suffix){
        parent::admin_enqueue_scripts($hook_suffix);
    }

    
    /**
     * Loading styles and scripts only on wp front-end.
     *
     * @param string $hook_suffix
     * @return void
     */
    function front_enqueue_scripts($hook_suffix){
        parent::front_enqueue_scripts($hook_suffix);
    }
    
    public function plugin_header(){
        echo $this->get_framework_view("Plugin", "header.php");
    }

    public function plugin_footer(){
        echo $this->get_framework_view("Plugin", "footer.php");
    }

    public static function get_yps_plugin_list($only_active = false){
        $plugins        = get_plugins();
        $yps_plugins    = array();

        foreach($plugins as $plugin){
            if($plugin['Author'] == 'yourplugins.com'){

                if($only_active == true && is_plugin_active("{$plugin['TextDomain']}/{$plugin['TextDomain']}.php") == false){
                    continue;
                }else{
                    $yps_plugins[]      = $plugin;
                }
                
            }
        }

        return $yps_plugins;
    }

}


