<?php

namespace YPS\Framework\Settings\v481_380_927;

use YPS\Framework\Core\v481_380_927\Helper;
use YPS\Framework\Core\v481_380_927\View;
use YPS\Framework\Record\v481_380_927\Record_Controller;

class Settings_Controller extends Record_Controller {
    
	public $message;

	public function __construct($context, $params = array()) {
        parent::__construct($context, $params);
    }

    public function index_action(){
        $this->settings_action();
    }

    public function settings_action(){

		$validate       = array(
            'errors'        => array(),
            'warnings'      => array()
        );

        $message        		= null;
        $raw            		= Helper::get_request("raw");

        if(Helper::get_request("form_task") == "save" || Helper::get_request("ajax_action") == "submit"){

            $data               = $this->record_form->get_request_data();
            $data               = $this->get_custom_action_data(__FUNCTION__, $data);

            $validate           = $this->record_form->validate($data);
			
			$this->record_entity->set_form_data($this->record_form, $data);

            if(count($validate['errors']) == 0){
                $message            = $this->message;
                
                $this->record_model->save($this->record_entity);

                $this->custom_after_settings_save();

                if($raw == false){
                    $this->redirect($this->record_config->get_settings_url($raw));
                }
                
            }
        }else if(Helper::get_request("ajax_action") == "reload"){
            $data               = $this->record_form->get_request_data();
			$this->record_entity->set_form_data($this->record_form, $data);
        }
        
		/*
		$view_module		= "Form";
        $view_path          = 'form/form.php';

        $view_params        = $this->get_custom_settings_view_params(array(
			'form'                      => $this->record_form,
			'entity'					=> $this->record_entity,

            'ajax_url'                  => null,
            'message'                   => $message,
            'form_validate'             => $validate,
        ));

        if($raw == false){
            echo $this->get_framework_view($view_module, $view_path, $view_params);
        }else{
            $this->set_response(array(
                'status'    => (count($validate['errors']) == 0)?true:false,
                'type'      => 'ajax-form'
            ), Controller::RESPONSE_JSON_FRAMEWORK_VIEW, $view_module, $view_path, $view_params);
        }
		*/

		$this->form_view->set_framework_template("Form", "form/form.php");

        $this->form_view->set_view_params($this->get_edit_view_params(array(
            'form'                      => $this->record_form,
            'entity'					=> $this->record_entity,

            'ajax_url'                  => $this->record_config->get_settings_url(true),
            'message'                   => $message,
            'form_validate'             => $validate,
        )));

        $this->form_view->set_view_json_data($this->get_edit_view_json_data(array(
            'status'    => (count($validate['errors']) == 0)?true:false,
            'type'      => 'ajax-form',
            'record_id' => $this->record_id
        )));

        if($this->raw == false){
            $this->form_view->set_output_mode(View::VIEW_OUTPUT_MODE_HTML);
        }else{
            $this->form_view->set_output_mode(View::VIEW_OUTPUT_MODE_HTML_AND_JSON);
        }

        return $this->form_view;
    }


	public function get_custom_entity($entity){
		$entity->set_data($this->record_model->get_values());

		return $entity;
	}

	public function get_custom_action_data($action, $data){
		return $data;
	}

    public function get_custom_settings_view_params($view_params){
        return $view_params;
    }

    public function custom_after_settings_save(){}
	public function get_edit_header_view(){}
	
	/**
	 * Get the value of settings_form
	 *
	 * @return mixed
	 */
	public function get_settings_form(){
		return $this->get_record_form();
	}

	/**
	 * Set the value of settings_form
	 *
	 * @param   mixed  $settings_form  
	 *
	 * @return  self
	 */
	public function set_settings_form($settings_form){
		$this->set_record_form($settings_form);

		return $this;
	}

	/**
	 * Get the value of settings_model
	 *
	 * @return mixed
	 */
	public function get_settings_model(){
		return $this->get_record_model();
	}

	/**
	 * Set the value of settings_model
	 *
	 * @param   mixed  $settings_model  
	 *
	 * @return  self
	 */
	public function set_settings_model($settings_model){
		$this->set_record_model($settings_model);

		return $this;
    }

    /**
	 * Get the value of settings_entity
	 *
	 * @return mixed
	 */
	public function get_settings_entity(){
		return $this->get_record_entity();
	}

	/**
	 * Set the value of settings_entity
	 *
	 * @param   mixed  $settings_entity  
	 *
	 * @return  self
	 */
	public function set_settings_entity($settings_entity){
		$this->set_record_entity($settings_entity);

		return $this;
	}

	/**
	 * Get the value of settings_config
	 *
	 * @return mixed
	 */
	public function get_settings_config(){
		return $this->get_record_config();
	}

	/**
	 * Set the value of settings_config
	 *
	 * @param   mixed  $settings_config  
	 *
	 * @return  self
	 */
	public function set_settings_config($settings_config){
		$this->set_record_config($settings_config);

		return $this;
	}
}